unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MyFunc, JwwGaibu, StdCtrls ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    px,py : double ;
    col,ltp,wid : integer ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
    procedure OpenLstFile ;
    procedure SaveLstFile ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   px := 0.0;
   py := 0.0;
   col:= 0;
   ltp:= 0;
   wid:=-1;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);  px := SDbl(s);
      ReadLn(F, s);  py := SDbl(s);
      ReadLn(F, s);  col:= SInt(s);
      ReadLn(F, s);  ltp:= SInt(s);
      ReadLn(F, s);  wid:= SInt(s);

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, FloatToStr(px));
      WriteLn(F, FloatToStr(py));
      WriteLn(F, IntToStr(col));
      WriteLn(F, IntToStr(ltp));
      WriteLn(F, IntToStr(wid));

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
end;

// f[^t@Cǂݍ
procedure TForm1.OpenLstFile ;
var
   fn: string ;
   F : TextFile ;
   i,j : integer ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.lst') ;
   ListBox1.Items.Clear ;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);  j := SInt(s);
      for i:=1 to j do begin
         ReadLn(F, s);
         ListBox1.Items.Add(s);
      end;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveLstFile ;
var
   fn: string ;
   F : TextFile ;
   i,j : integer ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.lst') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      j := ListBox1.Items.Count ;
      WriteLn(F, IntToStr(j));
      for i:=0 to j-1 do begin
         s := ListBox1.Items[i] ;
         WriteLn(F, s);
      end;

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
var
   i : integer ;
   s1,s2,s3,s4 : string ;
   w1,w2,w3,w4,w5,w6,w7,w8,w9 : double ;
begin
   if (ParamCount >= 1) then
      Form1.WindowState := wsMinimized ;
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   //
   OpenDatFile ;
   if (ParamCount >= 1) then begin
      S_Init ;       // 
      S_Col(col,1);  // F
      S_Ltp(ltp,1);  // 
      S_Wid(wid);    // 
      //
      if (ParamStr(1) = '/R0') then begin
         // Q_w
         S_Line(JG_IPoints[1].x , JG_IPoints[1].y,
                JG_IPoints[2].x , JG_IPoints[2].y );
         px := JG_IPoints[2].x ;
         py := JG_IPoints[2].y ;
      end
      else if (ParamStr(1) = '/R1') then begin
         // _w
         for i:=1 to 98 do begin
            if not(JG_IPoints[i+1].flg) then break;
            S_Line(JG_IPoints[i  ].x , JG_IPoints[i  ].y,
                   JG_IPoints[i+1].x , JG_IPoints[i+1].y );
            px := JG_IPoints[i+1].x ;
            py := JG_IPoints[i+1].y ;
         end;
      end
      else if (ParamStr(1) = '/R2') then begin
         // I_w
         S_Line(px,py, JG_IPoints[1].x , JG_IPoints[1].y);
         px := JG_IPoints[1].x ;
         py := JG_IPoints[1].y ;
      end
      else if (ParamStr(1) = '/R3') then begin
         // W
         s1 := '0.0';   if (ParamCount >= 2) then s1:=ParamStr(2);
         s2 := '0.0';   if (ParamCount >= 3) then s2:=ParamStr(3);
         s3 := '0.0';   if (ParamCount >= 4) then s3:=ParamStr(4);
         s4 := '0.0';   if (ParamCount >= 5) then s4:=ParamStr(5);
         w1 := 0.0;
         w2 := 0.0;
         if (Copy(s1,1,1)='@') then begin
            w1 := px ;
            w2 := py ;
            s1 := Copy(s1,2,Length(s1));
         end;
         Rev(w5,w6, SDbl(s1),SDbl(s2),0.0,0.0,JG_Jikukaku);
         w1 := w1 + w5;
         w2 := w2 + w6;
         w3 := 0.0;
         w4 := 0.0;
         if (Copy(s3,1,1)='@') then begin
            w3 := w1 ;
            w4 := w2 ;
            s3 := Copy(s3,2,Length(s3));
         end;
         Rev(w5,w6, SDbl(s3),SDbl(s4),0.0,0.0,JG_Jikukaku);
         w3 := w3 + w5;
         w4 := w4 + w6;
         S_Line(w1,w2, w3,w4);
         px := w3 ;
         py := w4 ;
      end
      else if (ParamStr(1) = '/R4')
            or(ParamStr(1) = '/R5')
            or(ParamStr(1) = '/R6') then begin
         // EEpx
         w9 := JG_Jikukaku ;
         if      (ParamStr(1) = '/R5') then w9 := w9 + 90.0
         else if (ParamStr(1) = '/R6') then w9 := w9 + SDbl(ParamStr(2)) ;
         // ʉߓ_
         Rev(w7,w8, JG_IPoints[1].x,JG_IPoints[1].y, 0.0,0.0, -w9);
         // n_
         Rev(w5,w6, JG_IPoints[2].x,JG_IPoints[2].y, 0.0,0.0, -w9);
         w6 := w8 ;
         Rev(w1,w2, w5,w6, 0.0,0.0, w9);
         // I_
         Rev(w5,w6, JG_IPoints[3].x,JG_IPoints[3].y, 0.0,0.0, -w9);
         w6 := w8 ;
         Rev(w3,w4, w5,w6, 0.0,0.0, w9);
         S_Line(w1,w2, w3,w4);
         px := w3 ;
         py := w4 ;
      end
      else if (ParamStr(1) = '/R7')
            or(ParamStr(1) = '/R8')
            or(ParamStr(1) = '/R9') then begin
         // sEEX
         if (JW_EntLineN = 0) then Close ;   // ǂݎĂȂ:ꉞ̃`FbN
         with JW_EntLine[0] do
            w9 := Angle(x2-x1,y2-y1)*180.0/Pi;
         if (w9 >= 180.0) then
            w9 := w9 - 180.0;
         if      (ParamStr(1) = '/R8') then w9 := w9 + 90.0
         else if (ParamStr(1) = '/R9') then w9 := w9 + SDbl(ParamStr(2)) ;
         // ʉߓ_
         Rev(w7,w8, JG_IPoints[2].x,JG_IPoints[2].y, 0.0,0.0, -w9);
         // n_
         Rev(w5,w6, JG_IPoints[3].x,JG_IPoints[3].y, 0.0,0.0, -w9);
         w6 := w8 ;
         Rev(w1,w2, w5,w6, 0.0,0.0, w9);
         // I_
         Rev(w5,w6, JG_IPoints[4].x,JG_IPoints[4].y, 0.0,0.0, -w9);
         w6 := w8 ;
         Rev(w3,w4, w5,w6, 0.0,0.0, w9);
         S_Line(w1,w2, w3,w4);
         px := w3 ;
         py := w4 ;
      end;
      SaveDatFile ;
      Close ;
   end
   else begin
      // ݒ
      Form1.Left := Mouse.CursorPos.X - Form1.Width  div 2;
      Form1.Top  := Mouse.CursorPos.Y - Form1.Height div 2;
      //
      ComboBox1.Items.Clear ;
      ComboBox1.Items.Add('ݐF');
      for i:=1 to 9 do
         ComboBox1.Items.Add('F'+IntToStr(i));
      for i:=1 to 256 do
         ComboBox1.Items.Add('SXF-'+IntToStr(i));
      ComboBox2.Items.Clear ;
      ComboBox2.Items.Add('ݐ');
      for i:=1 to 9 do
         ComboBox2.Items.Add(''+IntToStr(i));
      for i:=1 to 5 do
         ComboBox2.Items.Add('_'+IntToStr(i));
      for i:=1 to 4 do
         ComboBox2.Items.Add('{'+IntToStr(i));
      for i:=1 to 32 do
         ComboBox2.Items.Add('SXF-'+IntToStr(i));
      ComboBox3.Text := '' ;
      //
      ComboBox1.ItemIndex := col ;
      ComboBox2.ItemIndex := ltp ;
      if (wid >= 0) then
         ComboBox3.Text := IntToStr(wid);
      //
      OpenLstFile ;
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (ParamCount >= 1) then begin
      // JWC_TEMP.TXTۑ܂
      SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   end;
   // ŏI
   EndJwwGaibu ;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
begin
   col := ComboBox1.ItemIndex ;
   ltp := ComboBox2.ItemIndex ;
   if (ComboBox3.Text = '') then
      wid := -1
   else
      wid := SInt(ComboBox3.Text);
   SaveDatFile ;
   SaveLstFile ;
   Close ;
end;

// [Cancel]
procedure TForm1.Button2Click(Sender: TObject);
begin
   SaveLstFile ;
   Close ;
end;

// [o^]
procedure TForm1.Button3Click(Sender: TObject);
var
   s : string ;
begin
   s := 'C=' + IntToStr(ComboBox1.ItemIndex)
      +' L=' + IntToStr(ComboBox2.ItemIndex)
      +' W=' + ComboBox3.Text ;
   ListBox1.Items.Add(s);
end;

// [폜]
procedure TForm1.Button4Click(Sender: TObject);
var
   i : integer ;
begin
   if (ListBox1.Items.Count = 0) then exit ;
   i := ListBox1.ItemIndex ;
   if (i >= 0) then
      ListBox1.Items.Delete(i);
end;

// [I]
procedure TForm1.ListBox1Click(Sender: TObject);
var
   i : integer ;
   s,t : string ;
begin
   if (ListBox1.Items.Count = 0) then exit ;
   i := ListBox1.ItemIndex ;
   if (i >= 0) then begin
      s := ListBox1.Items[i] ;
      i := AnsiPos(' L=',s);
      t := Copy(s,3,i-3) ;
      s := Copy(s,i+3,Length(s));
      ComboBox1.ItemIndex := SInt(t) ;
      i := AnsiPos(' W=',s);
      t := Copy(s,1,i-1) ;
      s := Copy(s,i+3,Length(s));
      ComboBox2.ItemIndex := SInt(t) ;
      ComboBox3.Text := s ;
   end;
end;

end.
 